	.text
sum:
	pushl	%ebp		# save old base pointer into stack
	movl	%esp, %ebp	# make current stack position the base pointer
	movl	8(%ebp), %eax	# put first argument into %eax. Move two bytes, one for return
	movl	12(%ebp), %ebx	# put second argument info %ebx
	addl	%ebx, %eax	# add value into %eax register, which will be the return value

	# restore stack before returning
	movl	%ebp, %esp	# restore stack pointer as it was before this call
	popl	%ebp		# restore base pointer
	ret
	
	.global	_start
_start:
	pushl	$10		# push second value in stack register %esp first
	pushl	$5		# push first value in stack register %esp second
	call	sum		# call function, which stores result in %eax register

	# get the result as exit code
	movl	%eax, %ebx	# The status code
	movl	$1, %eax	# Syscall number for EXIT
	int	$0x80		# Poke the kernel. This will end the program
