: " Command file for the Thompson Shell "
:
: " Build the Assembly programs, and clean the resulting object and "
: " executable files thereafter.                                    "
:
: " Build if no verb is given.                                "
: " Exit with zero status on success.                         "
: " Print diagnostic, and exit with non-zero status on error. "
:
: " usage: sh build.sh [build | clean]  "

if X$1 = X"" -o X$1 = Xbuild goto BUILD
if X$1 = Xclean goto CLEAN
fd2 -e echo "error: Unknown verb: "$1""
false ; exit

: BUILD
as -o add.o add.s
as -o cat.o cat.s
as -o cmp.o cmp.s
as -o echo.o echo.s
as -o false.o false.s
as -o hello_world.o hello_world.s
as -o power.o power.s

ld -o add add.o
ld -o cat cat.o
ld -o cmp cmp.o
ld -o echo echo.o
ld -o power power.o

dd if=false.o of=false bs=1 skip=52 count=96
dd if=hello_world.o of=hello_world bs=1 skip=52 count=165

chmod 755 false
chmod 755 hello_world
exit

: CLEAN
rm -f *.o add cat cmp echo false hello_world power
