#ifndef STRING_H
#define STRING_H

#define NULL (void *)0
#define ATOI_MIN (-0xffffffL + 4096)

int atoi(const char *str, char **endptr, int base);
int itoa(int n, char *str, int base);
void *memcpy(void *dst, const void *src, unsigned long n);
void *memmove(void *dst, const void *src, unsigned long n);
int memcmp(const void *cs_in, const void *ct_in, unsigned long n);
void *memset(void *dst, int ch, unsigned long n);
char *strrchr(const char *str, int ch);
unsigned long strlen(const char *str);
unsigned long strspn(const char *str, const char *accept);
unsigned long strcspn(const char *str, const char *accept);
int strcmp(const char *str1, const char *str2);
char *strstr(const char *str, const char *substr);
char *strchr(const char *str, int ch);
char *strpbrk(const char *str, const char *accept);
char *strtok(char *str, const char *delim, char **saveptr);
char *strerror(int errno);

#endif
