#include <signal.h>
#include <string.h>

int signal(int sig, void (*handler)(int))
{
	struct sigaction act;

	act.sa_handler = handler;
	act.sa_mask.val[0] = 0;
	act.sa_mask.val[1] = 0;
	act.sa_mask.val[2] = 0;
	act.sa_flags = 0;

	return rt_sigaction(sig, &act, NULL);
}
