#include <string.h>

int memcmp(const void *cs_in, const void *ct_in, unsigned long n)
{
	unsigned long i = 0;
	const unsigned char *cs = (const unsigned char *)cs_in;
	const unsigned char *ct = (const unsigned char *)ct_in;

	for (i = 0; i < n; i++, cs++, ct++) {
		if (*cs < *ct)
			return -1;
		else if (*cs > *ct)
			return 1;
	}
	return 0;
}
