#include <string.h>

void *memmove(void *dst, const void *src, unsigned long n)
{
	char *d = (char *)dst;
	char *s = (char *)src;

	if (s < d) {
		s += n;
		d += n;

		while (n--)
			*--d = *--s;
	} else {
		while (n--)
			*d++ = *s++;
	}
	return dst;
}
