#include <bits/ioctl.h>
#include <errno.h>
#include <fcntl.h>
#include <stat.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <unistd.h>

int ttyname(int fd, char *name, unsigned int size)
{
	char procname[32] = { "/proc/self/fd/\0" };
	int l;
	int ret;
	struct termios term;
	struct stat fd_stat;
	struct stat dev_stat;

	ret = ioctl(fd, TCGETS, &term);
	if (ret < 0)
		return ret;
	procname[14] = fd > 9 ? 0 : fd + 48;
	l = readlinkat(AT_FDCWD, procname, name, size);

	if (l < 0)
		return l;
	else if (l == size)
		return -ERANGE;

	name[l] = '\0';

	ret = fstatat64(AT_FDCWD, name, &dev_stat, 0);
	if (ret < 0)
		return ret;
	ret = fstatat64(fd, "", &fd_stat, AT_EMPTY_PATH);
	if (ret < 0)
		return ret;
	if (dev_stat.st_dev != fd_stat.st_dev || dev_stat.st_ino != fd_stat.st_ino)
		return -ENODEV;

	return 0;
}
