#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>

int main(void)
{
	char d_type;
	char buf[4096];
	int nread;
	int bpos = 0;
	int fd;
	struct dirent *d = (void *)buf;

	fd = open(".", O_RDONLY | O_DIRECTORY, 0);
	if (fd < 0) {
		put(2, "open: ");
		put_line(2, strerror(-fd));	
		return 1;
	}
	nread = getdents(fd, d, sizeof(buf));
	if (nread < 0) {
		put(2, "getdents: ");
		put_line(2, strerror(-nread));
		return 1;
	}
	while (bpos < nread) {
		d_type = *(buf + bpos + (*d).d_reclen - 1);
		if (d_type == DT_DIR) {
			put(1, "\033[1;34m");
			put(1, (*d).d_name);
			put(1, "\033[0m\n");
		} else {
			put_line(1, (*d).d_name);
		}
		bpos += (*d).d_reclen;
		d = (void *)(buf + bpos);
	}
	close(fd);
	return 0;
}
