@ A program that prints "Hello World!"
.byte	0x7f
.byte	0x45	@ E
.byte	0x4c	@ L
.byte	0x46	@ F
.byte	0x01	@ 32 bit ; CLASS
.byte	0x01	@ lsb ; DATA
.byte	0x01	@ VERSION
.byte	0x00	@ None/System V ; OS ABI
.8byte	0x1000000000000000	@ ABI VERSION + PADDING
.2byte	0x02	@ ET_EXEC ; E_TYPE
.2byte	0x28	@ ARM ; E_MACHINE
.4byte	0x01	@ E_VERSION
.4byte	0x10074	@ E_ENTRY
.4byte	0x34	@ offset into program header ; E_PHOFF
.4byte	0x00	@ offset into section header ; E_SHOFF
.4byte	0x5000200	@ E_FLAGS
.2byte	0x34	@ ELF header size ; E_EHSIZE
.2byte	0x20	@ Program header size ; E_PHENTSIZE
.2byte	0x02	@ Number of program headers ; E_PHNUM
.2byte	0x00	@ Sections header size ; E_SHENTSIZE
.2byte	0x00	@ Number of section headers ; E_SHNUM
.2byte	0x00	@ Section header string table index ; E_SHSTRNSX

.4byte	0x01	@ PT_LOAD ; P_TYPE
.4byte	0x00	@ Offset of entry
.4byte	0x10000	@ P_VADDR
.4byte	0x00	@ P_PADDR
.4byte	0x94	@ P_FILESIZE
.4byte	0x94	@ P_MEMSZ
.4byte	0x05	@ R-X ; P_FLAGS
.4byte	0x10000	@ P_ALIGN

.4byte	0x01	@ PT_LOAD ; P_TYPE
.4byte	0x94	@ Offset of entry
.4byte	0x20094	@ P_VADDR
.4byte	0x00	@ P_PADDR
.4byte	0x0e	@ P_FILESIZE
.4byte	0x0e	@ P_MEMSZ
.4byte	0x06	@ R-X ; P_FLAGS
.4byte	0x10000	@ P_ALIGN

@ Text
mov	r7, $4		@ Setup service call 4 (write)
mov	r0, #1		@ Parameter 1 - file descripter 1 = STDOUT
ldr	r1, [pc, #16]	@ Parameter 2 - address of string to print
mov	r2, #14		@ Parameter 3 - length of string
svc	#0		@ Ask Linux kernel to write to STDOUT
mov	r7, #1		@ Setup service call 1 (exit)
mov	r0, #0		@ Parameter 1 - 0 = normal exit
svc	#0		@ Ask Linux kernel to terminate this program

@ Data
.ascii	"Hello, World!\n"
