@ Reads data from one point in data, copies it, and then
@ outputs the result

.data
instr: .ascii "Summer"
outstr: .fill 7, 1, 0

.text
.global _start
_start:
	ldr r0, =instr           @ load instr address
	ldr r1, =outstr          @ load outstr address
	movw r2, #0              @ assign 0 to counter

loop:
	ldrb r3, [r0]            @ load character from instr
	strb r3, [r1]            @ store character in outstr
	add r0, #1               @ increment instr
	add r1, #1               @ increment outstr
	add r2, #1               @ increment counter
	cmp r2, #6               @ compare counter to length
	bne loop                 @ do it again if not equal

	movw r3, #'\n'           @ load newline for outstr
	strb r3, [r1]            @ store newline

	movw r0, #1              @ fd := 1
	ldr r1, =outstr          @ buf := msg
	movw r2, #7              @ count := len
	movw r7, #4              @ write is syscall 4
	swi #0                   @ invoke syscall

	movw r0, #0              @ status := 0
	movw r7, #1              @ exit is syscall 1
	swi #0                   @ invoke syscall
