# should be a replacement for /bin/echo
	.data
separator:
	.string " "
eoln:
	.string "\n"

	.text
	.global _start

# calling writestr:
#   first argument goes into %ebx  == 1, stdout
#   second argument goes into %ecx == pointer to str1 

strlen:
	push	%ebp
	movl	%ebp, %esp
	movl	%edx, (%ebp+8)	# the string
	xor	%eax, %eax	# loop counter
	jmp	strlen_if
strlen_then:
	incl	%eax		# increment loop counter
strlen_if:
	movl	%cl, (%edx+%eax)
	cmp	%cl, $0
	jne	strlen_then	
	pop	%ebp
	ret

_start:
	pop	%esi		# this is argc
	pop 	%ecx		# remove command, throw this away
	dec	%esi
	jz	finish		# check for no args left in argv

around:
	pop	%ecx		# this is the next *argv --- could test here since you are through when this a NULL pointer!

	movb	(%ecx), %dl	# check to see if this just an empty string (so we don't do a separator)
	or	%dl, %dl
	jz	shortcut	# if that's just a zero byte at the beginning, skip it...
	
	mov	$1, %ebx	# %ecx is already setup
	call	strlen
	call	writestr

	mov	$1, %ebx
	lea	separator, %ecx
	call	writestr

shortcut:
	dec	%esi
	jnz	around

	mov	$1, %ebx
	lea	eoln, %ecx
	call	writestr

finish:
	mov	$0, %ebx	# and exit with a zero status
	mov	$1, %eax
	int	$0x80
