#define IOC(a, b, c, d) (((a) << 30) | ((b) << 8) | (c) | ((d) << 16))
#define IOC_NONE  0U
#define IOC_WRITE 1U
#define IOC_READ  2U

#define IO(a,b) IOC(IOC_NONE, (a), (b), 0)
#define IOW(a,b,c) IOC(IOC_WRITE, (a), (b), sizeof(c))
#define IOR(a,b,c) IOC(IOC_READ, (a), (b), sizeof(c))
#define IOWR(a,b,c) IOC(IOC_READ | IOC_WRITE, (a), (b), sizeof(c))

#define TCGETS 0x5401
#define TCSETS 0x5402
#define TIOCSCTTY 0x540e
