#ifndef FCNTL_H
#define FCNTL_H

#define O_RDONLY 00
#define O_WRONLY 01
#define O_RDWR 02
#define O_CREAT 0100
#define O_TRUNC 01000
#define O_APPEND 02000
#define O_NONBLOCK 04000
#define O_DIRECTORY 040000
#define O_CLOEXEC 02000000
#define O_LARGEFILE 0400000
#define O_PATH 010000000 /* Can be used to get dirfd. */

#define F_DUPFD 0
#define F_GETFD 1
#define F_SETFD 2
#define F_GETFL 3
#define F_SETFL 4

#define AT_FDCWD -100
#define AT_SYMLINK_NOFOLLOW 0x100
#define AT_REMOVEDIR 0x200
#define AT_EMPTY_PATH 0x1000

#define F_OK 0
#define R_OK 4
#define W_OK 2
#define X_OK 1

extern int open(const char *filename, int flags, int mode);
extern int fcntl(int fd, int cmd, int arg);

#endif
