# The jmp_buf is assumed to contain the following, in order:
#   %ebx, %esp, %ebp, %esi, %edi, <return address>
	.text
	.align	4
	.global	setjmp
	.type	setjmp, @function
setjmp:
	movl	4(%esp), %edx
	popl	%ecx			# Return address, and adjust the stack
	xorl	%eax, %eax		# Return value
	movl	%ebx, (%edx)
	movl	%esp, 4(%edx)		# Post-return %esp!
	pushl	%ecx			# Make the call/return stack happy
	movl	%ebp, 8(%edx)
	movl	%esi, 12(%edx)
	movl	%edi, 16(%edx)
	movl	%ecx, 20(%edx)		# Return address
	ret
	.size setjmp, .-setjmp
