#include <string.h>

int itoa(int n, char *str, int base)
{
	char tmp[16];
	char *tp = tmp;
	int i;
	int len;

	while (n || tp == tmp) {
		i = n % base;
		n /= base;
		if (i < 10)
			*tp++ = i + '0';
		else
			*tp++ = i + 'a' - 10;
	}
	len = tp - tmp;
	while (tp > tmp)
		*str++ = *--tp;
	*str = '\0';

	return len;
}
