#include <string.h>

/* Find index of first str[i] that matches no accept[] */
unsigned long strspn(const char *str, const char *accept)
{
	const char *p;
	const char *a;

	for (p = str; *p != '\0'; p++) {
		for (a = accept; *a != *p; a++) {
			if (*a == '\0')
				return p - str;
		}
	}
	return p - str;
}
