#include <string.h>

char *strtok(char *str, const char *delim, char **saveptr)
{
	char *end;

	if (str == NULL)
		str = *saveptr;
	if (*str == '\0') {
		*saveptr = str;
		return NULL;
	}
	str += strspn(str, delim);
	if (*str == '\0') {
		*saveptr = str;
		return NULL;
	}
	end = str + strcspn(str, delim);
	if (*end == '\0') {
		*saveptr = end;
		return str;
	}
	*end = '\0';
	*saveptr = end + 1;
	return str;
}
