#include <signal.h>
#include <setjmp.h>
#include <stdio.h>
#include <string.h>

jmp_buf buf;

void signal_handler(int sig)
{
	if (sig == SIGSEGV) {
		put_line(1, "Segmentation fault caught! Attempting recovery..");
		longjmp(buf, 1);
	}
}

int main(void)
{
	int *ptr = NULL;

	signal(SIGSEGV, signal_handler);

	if (!setjmp(buf)) {
		*ptr = 1;
	} else {
		put_line(1, "Successfully recovered");
	}
	return 0;
}
